import random

win_steps = [{0, 1, 2}, {3, 4, 5}, {6, 7, 8}, {0, 3, 6}, {1, 4, 7}, {2, 5, 8}, {0, 4, 8}, {2, 4, 6}]

def smart_play(steps,current_player):
    if len(steps) == 0:
        return 0
    if len(steps) == 2:
        if steps[1] in [3, 5]:return 2
        if steps[1] in [1, 7]: return 6
        if steps[1] in [2, 6, 8]: return random.choice([x for x in [2,6,8] if x not in steps])
        if steps[1] == 4 : return 8

    r = get_import_step(steps,current_player)
    if r: return random.choice(r[0])
    r = get_import_step(steps, 1 if current_player==0 else 0)
    if r: return random.choice(r[0])

    if len(steps) == 4:
        if 8 not in steps : return 8
        return random.choice([x for x in [2, 6] if x not in steps])

def get_import_step(steps,player):
    current_player_steps = [step for i, step in enumerate(steps) if i % 2 == player]
    ps = [set(current_player_steps) | {item} for item in {0, 1, 2, 3, 4, 5, 6, 7, 8} - set(steps)]
    r = [list(p - set(current_player_steps)) for p in ps if any([item.issubset(p) for item in win_steps])]
    return r

def random_play(steps):
    return random.choice([x for x in range(9) if x not in steps])